<template>
<!--
	Comments will be fetched prior to the event as long as event is being declared undefined.
	If I declare it as an empty object, event _is_ fetched first, but I get error messages because it's
	content is being accessed before it's ready. ==> <div v-if="event"...
	(Tested by setting a break point in the CommentController, to see if the event is shown without comments.
	Sadly everything was on hold until comments were ready as well. Tried out a few things, always identical results)
-->
	<main>
		<div v-if="event" class="cards cards--dual">
			<h1 class="card--merged">{{ event.title }}</h1>

			<admin-toolbar v-if="isAdmin" :event-id="event.id" class="card--merged" />

			<div class="cols r-0-1">
				<div class="card-body">
					<h5 class="h--tilt-left">{{ event.eventType.title }}</h5>
					<div class="cols c-0-1">
						<p class="cell"><b>Start:</b></p>
						<p class="cell bg-4"> {{ globalDateToString(event.dateStart) }}</p>

						<template v-if="event.dateStart !== event.dateEnd">
							<p class="cell"><b>Ende:</b></p>
							<p class="cell bg-4"> {{ globalDateToString(event.dateEnd) }}</p>
						</template>

						<p class="cell"><b>Einlass:</b></p>
						<p class="cell bg-4">{{ event.doorsOpen.substr(0, 5) }} Uhr</p>
						<p class="cell"><b>Preis:</b></p>
						<p class="cell bg-4">EUR {{ event.price }} ,-</p>
						<p class="cell"><b>Dabei:</b></p>
						<p class="cell bg-4">{{ event.totalUsersAttendingEvent }} BenutzerInnen</p>
					</div>

					<div class="card-buttons flex">
						<button @click="$router.back()" class="button button--mobile-stretch flex-stretch">Zur&uuml;ck</button>
						<a href="https://www.oeticket.com" title="Tickets kaufen" target="_blank" class="button button--mobile-stretch flex-stretch">Tickets</a>

						<template v-if="isLoggedIn">
							<button v-if="!isAttending" class="button button--mobile-stretch flex-stretch" @click="toggleAttendance(true)">Count me in!</button>
							<button v-else class="button button--mobile-stretch flex-stretch" @click="toggleAttendance(false)"><s>Count me out!</s></button>
						</template>
					</div>

				</div>
				<div class="card-body hidden-mobile">
					<img class="card-flyer" :src="baseUrl + '/program/' + event.image" :alt="event.title" :title="event.title" />
				</div>
			</div>
			<div class="card-body">
				<p class="nl2br">
					{{ event.text }}
				</p>
			</div>
		</div>

		<event-comments :event-id="id" />

		<system-message v-if="sysMsg" :msg.sync="sysMsg" />

		<loader v-if="isLoading" />
	</main>

</template>

<script>
import SystemMessage from "@/components/SystemMessage";
import AdminToolbar from "@/components/admin/AdminToolbar";
import Loader from "@/components/Loader";
import EventComments from "@/components/EventComments";

export default {
	name: "EventSingle",
	components: {
		EventComments,
		Loader,
		AdminToolbar,
		SystemMessage
	},
	props: {
		id: String,
		page: String
	},
	data: () => ({
		savedRoute: null,
		isLoading: false,
		event: undefined,
		isAttending: Boolean,
		sysMsg: undefined
	}),
	methods: {
		async fetchEvent() {
			const response = await this.$http.get("/api/event/" + this.id);
			this.event = response.data;
		},

		async checkAttendance() {
			if(this.isLoggedIn) {
				const response = await this.$http.get("/api/attendance/" + this.id + "/" + this.$store.getters.getUserId);
				this.isAttending = response.data;
			}
		},

		async toggleAttendance(add = false) {
			if(this.isLoggedIn) {
				let attendedEventsDTO = {
					"userId": this.$store.getters.getUserId,
					"eventId": this.id
				}

				let suffix = add ? "add" : "remove";

				this.isLoading = true;
				const response = await this.$http.post("/api/attendance/" + suffix, attendedEventsDTO);
				if (response.status === 200) {
					await this.fetchEvent();
					await this.checkAttendance();
				}
				this.isLoading = false;
			}
		}
	},
	computed: {
		isLoggedIn() {
			return this.$store.getters.isLoggedIn;
		},
		isAdmin() {
			return this.$store.getters.isAdmin;
		},
		baseUrl() {
			return process.env.VUE_APP_BASE_URL;
		}

	},
	mounted() {
		this.isLoading = true;
		this.fetchEvent();
		this.checkAttendance();
		this.isLoading = false;
	}
}
</script>

<style scoped>

</style>